import java.util.Calendar;
import java.util.Hashtable;
import java.util.Vector;

import quadbase.reportdesigner.util.IExportConstants;
import quadbase.reportorganizer.organizerAPI.QbOrganizer;
import quadbase.reportorganizer.organizerAPI.QbScheduleObject;
import quadbase.reportorganizer.organizerAPI.QbSchedulePackage;

public class SchedulingParamPackageEmailERES {
	// set following constants, your ERES server must be runnning!
	static final String ServletRunner = "http://localhost:8080";
	static final String ServletContext = "ERES/servlet";

	public static void main(String[] args) {
		SchedulingParamPackageEmailERES doSchedulePackage = new SchedulingParamPackageEmailERES();
		try {
			doSchedulePackage.createScheduleObject();
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	void createScheduleObject() throws Exception {
		QbOrganizer.setServletContext(ServletContext);
		QbOrganizer.setServletRunner(ServletRunner);
		QbOrganizer organizer = new QbOrganizer(null, "admin", "admin");

		QbSchedulePackage sPack = new QbSchedulePackage("ParamPackage_Email", organizer);
		sPack.setReportExportType(IExportConstants.PDF);
		sPack.setTaskOption(QbSchedulePackage.ONE_TIME);
		Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.MINUTE, 10);
		sPack.setStartDate(calendar.getTimeInMillis());
		sPack.setSendEmail(true);
		sPack.setFromAddress("user1@quadbase.com");
		sPack.setSubject("Schedule Param Package Email");
		sPack.setBodyText("Schedule Package export containing a report and a parameterized report\n"
				+
				"<SAVED_LINKS></SAVED_LINKS>");
		sPack.setEmailType(QbSchedulePackage.NONE);

		QbScheduleObject rptObj1 = new QbScheduleObject("new project/Account",
				QbScheduleObject.TEMPLATE_TYPE_REPORT, sPack);
		rptObj1.setFileLocation("Account.rpt");
		String exportLocation1 = rptObj1.pickDefaultExportLocation();
		rptObj1.setToAddresses(new String[] { "user2@quadbase.com" });

		QbScheduleObject rptObj2 = new QbScheduleObject("new project/EmployeeDetails",
				QbScheduleObject.TEMPLATE_TYPE_REPORT, sPack);
		rptObj2.setFileLocation("EmployeeDetails.pak");
		String exportLocation2 = rptObj2.pickDefaultExportLocation();
		//1st param set {"Denise Carron"}
		Object tmp1[] = { "Denise Carron" };
		//2nd param set {"Frank Carnody"}
		Object tmp2[] = { "Frank Carnody" };
		Vector paramList = new Vector();
		paramList.addElement(tmp1);
		paramList.addElement(tmp2);

		Vector paramNameList = new Vector();
		paramNameList.addElement("Denise");
		paramNameList.addElement("Frank");
		rptObj2.setParamList(paramNameList, paramList);

		Hashtable toAddr = new Hashtable();
		toAddr.put("Denise", new String[] { "user2@quadbase.com" });
		toAddr.put("Frank", new String[] { "user3@quadbase.com" });
		rptObj2.setParamAddresses(toAddr);

		organizer.getScheduler().addSchedulePackageTask(sPack);
	}

}
